--
-- VHDL Architecture Cosmix_lib.ClockGen.SIMPLE
--
-- Created:
--          by - goodrick.UNKNOWN (PCCO)
--          at - 10:31:48 14/11/2005
--
-- using Mentor Graphics HDL Designer(TM) 2003.2 (Build 28)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.all;

ENTITY ClockGen IS
   PORT( 
      CK100H : OUT    std_logic;
      CK100K : OUT    std_logic;
      GK50M  : IN     std_logic;
      Rst    : IN     std_logic
   );

-- Declarations

END ClockGen ;

--
ARCHITECTURE SIMPLE OF ClockGen IS
   signal Ctr100K : std_logic_vector (8 DOWNTO 0); -- 100KHz
   signal CK100Klast : std_logic ;
   signal Ctr100H : std_logic_vector (9 DOWNTO 0); -- 100Hz
BEGIN
   CK100K <= Ctr100K(8) ;
   CK100H <= Ctr100H(9) ;
--   
   ClockCount: process (GK50M, Rst)
   begin
      if(Rst = '1') then
        Ctr100K <= (others => '0') ;
        Ctr100H <= (others => '0') ;
        CK100Klast <= '0' ;
--      end if ;
--      if( rising_edge(GK50M)) then
        elsif( rising_edge(GK50M)) then
         CK100Klast <= Ctr100K(8) ;
         Ctr100K <= Ctr100K + 1 ;
         --Ctr100K    <= std_logic_vector(conv_unsigned(conv_integer(unsigned(Ctr100K)) + 1,9)) ;
         if((Ctr100K(8) = '1') and (CK100Klast = '0')) then
            Ctr100H  <= Ctr100H + 1 ;
            --Ctr100H    <= std_logic_vector(conv_unsigned(conv_integer(unsigned(Ctr100H)) + 1,10)) ;
         end if ;
      end if ;
   end process ClockCount ;
--   
END SIMPLE;

