--
-- VHDL Architecture Cosmix_lib.SpCoLog.Simple
--
-- Created:
--          by - goodrick.UNKNOWN (PCFV)
--          at - 14:03:26 14/12/2010
--
-- using Mentor Graphics HDL Designer(TM) 2007.1 (Build 19)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY SpCoLog IS
   GENERIC( 
      nstream : integer := 4
   );
   PORT( 
      CK50M : IN     std_logic;
      H     : IN     std_logic_vector (nstream-1 DOWNTO 0);
      M     : IN     std_logic_vector (nstream-1 DOWNTO 0);
      Veto  : IN     std_logic;
      Coinc : OUT    std_logic
   );

-- Declarations

END SpCoLog ;

--
ARCHITECTURE Simple OF SpCoLog IS
signal LAST  : std_logic;
signal MATCH : std_logic;

BEGIN
  
  Coinc <= MATCH ;
  
  process (CK50M)
  begin
    if (rising_edge(CK50M)) then
      if((M /= "0000") AND ((H AND M) = M)) then
        if((LAST = '0') AND (Veto = '0')) then
          MATCH <= '1';
        else
          MATCH <= '0';
        end if ;
        LAST <= '1' ;
      else
        LAST <= '0' ;
        MATCH <= '0';
      end if ;
    end if ;
   end process ;
--

END ARCHITECTURE Simple;

