-- VHDL Entity Cosmix_lib.cosmixer.symbol
--
-- Created:
--          by - Matthew.UNKNOWN (PCJL)
--          at - 10:12:01 02/08/2012
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2010.3 (Build 21)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY cosmixer IS
   GENERIC( 
      nstream : integer := 4;
      ncoinc  : integer := 6
   );
   PORT( 
      CK50M   : IN     std_ulogic;
      PRST    : IN     std_logic;
      Pulse   : IN     std_logic_vector (nstream-1 DOWNTO 0);
      SPCK    : IN     std_logic;
      SPCSn   : IN     std_logic;
      SPMOSI  : IN     std_logic;
      CLEDn   : OUT    std_logic_vector (5 DOWNTO 0);
      D0SpCSn : OUT    std_logic;
      D1SpCSn : OUT    std_logic;
      D2SpCSn : OUT    std_logic;
      D3SpCSn : OUT    std_logic;
      HLEDn   : OUT    std_logic_vector (3 DOWNTO 0);
      SDCK    : OUT    std_logic;
      SDCLn   : OUT    std_logic;
      SDCSn   : OUT    std_logic;
      SDDI    : OUT    std_logic;
      SPMISO  : OUT    std_logic;
      Sp0     : OUT    std_logic;
      Sp1     : OUT    std_logic;
      TRIG    : OUT    std_logic
   );

-- Declarations

END cosmixer ;

--
-- VHDL Architecture Cosmix_lib.cosmixer.struct
--
-- Created:
--          by - Matthew.UNKNOWN (PCJL)
--          at - 10:12:14 02/08/2012
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2010.3 (Build 21)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

LIBRARY unisim;
USE unisim.all;

LIBRARY Cosmix_lib;
USE Cosmix_lib.Cosmix.all;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.all;


ARCHITECTURE struct OF cosmixer IS

   -- Architecture declarations

   -- Internal signal declarations
   SIGNAL CC        : std_logic_vector(ncoinc-1 DOWNTO 0);
   SIGNAL CK100H    : std_logic;
   SIGNAL CK100K    : std_logic;
   SIGNAL CK100M    : std_logic  := '0';
   SIGNAL CK200M    : std_logic  := '0';
   SIGNAL CLK0      : std_ulogic := '0';
   SIGNAL CLK1      : std_ulogic := '0';
   SIGNAL CLKIN     : std_ulogic := '0';
   SIGNAL CTCLR     : std_logic;
   SIGNAL CTEN      : std_logic;
   SIGNAL CTOE      : std_logic_vector(ncoinc-1 DOWNTO 0);
   SIGNAL CTWORD    : std_logic_vector(31 DOWNTO 0);
   SIGNAL FL        : std_logic_vector(ncoinc-1 DOWNTO 0);
   SIGNAL GK100M    : std_ulogic := '0';
   SIGNAL GK200M    : std_ulogic;
   SIGNAL GK50M     : std_ulogic := '0';
   SIGNAL GPRST     : std_logic  := '0';
   SIGNAL HFL       : std_logic_vector(nstream-1 DOWNTO 0);
   SIGNAL LOCKED0   : std_ulogic := '0';
   SIGNAL LOCKED1   : std_ulogic := '0';
   SIGNAL MM        : slv8array(ncoinc-1 DOWNTO 0);
   SIGNAL Outz      : std_logic_vector(15 DOWNTO 0);
   SIGNAL RST       : std_ulogic := '0';
   SIGNAL SPCKbuf   : std_logic;
   SIGNAL SPCSn1    : std_logic;
   SIGNAL SVar      : std_logic_vector(3 DOWNTO 0);
   SIGNAL ck        : std_logic;
   SIGNAL gnd       : std_ulogic;
   SIGNAL hit       : std_logic_vector(nstream-1 DOWNTO 0) BUS;
   SIGNAL hit_width : slv8array(nstream-1 DOWNTO 0) BUS;
   SIGNAL pulse_buf : std_logic_vector(nstream-1 DOWNTO 0);
   SIGNAL reset     : std_logic;
   SIGNAL reset1    : std_logic;
   SIGNAL sigOut    : std_logic_vector(nstream-1 DOWNTO 0);
   SIGNAL tDelay    : slv8array(nstream-1 DOWNTO 0);
   SIGNAL vdd       : std_ulogic;


   -- Component Declarations
   COMPONENT ClockGen
   PORT (
      CK100H : OUT    std_logic ;
      CK100K : OUT    std_logic ;
      GK50M  : IN     std_logic ;
      Rst    : IN     std_logic 
   );
   END COMPONENT;
   COMPONENT Count
   GENERIC (
      width : integer := 24
   );
   PORT (
      CtCk   : IN     std_logic ;
      CtClr  : IN     std_logic ;
      CtEn   : IN     std_logic ;
      CtGo   : IN     std_logic ;
      CtOE   : IN     std_logic ;
      CtWord : OUT    std_logic_vector (width-1 DOWNTO 0)
   );
   END COMPONENT;
   COMPONENT OBUFn
   PORT (
      Pn : OUT    std_logic ;
      I  : IN     std_logic 
   );
   END COMPONENT;
   COMPONENT SPI_CTR
   GENERIC (
      ncoinc : integer := 6
   );
   PORT (
      Rst   : IN     std_logic ;
      SPCK  : IN     std_logic ;
      SPDI  : IN     std_logic ;
      Outz  : OUT    std_logic_vector (15 DOWNTO 0);
      SPCSn : IN     std_logic ;
      CTEN  : OUT    std_logic ;
      CTOE  : OUT    std_logic_vector (ncoinc-1 DOWNTO 0);
      CTCLR : OUT    std_logic ;
      GCK   : IN     std_logic ;
      SVar  : OUT    std_logic_vector (3 DOWNTO 0);
      SPDO  : OUT    std_logic ;
      CTIN  : IN     std_logic_vector (31 DOWNTO 0)
   );
   END COMPONENT;
   COMPONENT SPI_DAC
   PORT (
      Rst   : IN     std_logic ;
      SPCK  : IN     std_logic ;
      SPDI  : IN     std_logic ;
      Outz  : OUT    std_logic_vector (15 DOWNTO 0);
      SPCSn : IN     std_logic ;
      SDCSn : OUT    std_logic ;
      SDCK  : OUT    std_logic ;
      SDCLn : OUT    std_logic ;
      SDDI  : OUT    std_logic ;
      GCK   : IN     std_logic ;
      SVar  : OUT    std_logic_vector (3 DOWNTO 0)
   );
   END COMPONENT;
   COMPONENT SpCoBlock
   GENERIC (
      nstream : integer := 4
   );
   PORT (
      CK50M : IN     std_logic ;
      CK_FL : IN     std_logic ;
      H     : IN     std_logic_vector (nstream-1 DOWNTO 0);
      M     : IN     std_logic_vector (nstream-1 DOWNTO 0);
      RST   : IN     std_logic ;
      Veto  : IN     std_logic ;
      Coinc : OUT    std_logic ;
      FL    : OUT    std_logic 
   );
   END COMPONENT;
   COMPONENT SpHitBlock
   PORT (
      clk       : IN     std_logic ;
      pulse     : IN     std_logic ;
      hit       : OUT    std_logic ;
      fl        : OUT    std_logic ;
      clk_fl    : IN     std_logic ;
      reset     : IN     std_logic ;
      out_width : IN     std_logic_vector (3 DOWNTO 0)
   );
   END COMPONENT;
   COMPONENT delay
   PORT (
      sigIn  : IN     std_logic ;
      sigOut : OUT    std_logic ;
      tDelay : IN     std_logic_vector (7 DOWNTO 0);
      GK200M : IN     std_logic ;
      GK50M  : IN     std_logic 
   );
   END COMPONENT;
   COMPONENT spi_cfg
   GENERIC (
      opc  : integer := 16#88#;
      ncfg : integer := 6
   );
   PORT (
      reset : IN     std_logic ;
      ck    : IN     std_logic ;
      SPDI  : IN     std_logic ;
      SPCSn : IN     std_logic ;
      SPDO  : OUT    std_logic ;
      cfg   : OUT    slv8array (ncfg-1 DOWNTO 0)
   );
   END COMPONENT;
   COMPONENT BUFG
   PORT (
      I : IN     std_ulogic;
      O : OUT    std_ulogic
   );
   END COMPONENT;
   COMPONENT CLKDLL
   GENERIC (
      CLKDV_DIVIDE          : real;
      DUTY_CYCLE_CORRECTION : boolean;
      FACTORY_JF            : bit_vector;
      STARTUP_WAIT          : boolean
   );
   PORT (
      CLKFB  : IN     std_ulogic  := '0';
      CLKIN  : IN     std_ulogic  := '0';
      RST    : IN     std_ulogic  := '0';
      CLK0   : OUT    std_ulogic  := '0';
      CLK180 : OUT    std_ulogic  := '0';
      CLK270 : OUT    std_ulogic  := '0';
      CLK2X  : OUT    std_ulogic  := '0';
      CLK90  : OUT    std_ulogic  := '0';
      CLKDV  : OUT    std_ulogic  := '0';
      LOCKED : OUT    std_ulogic  := '0'
   );
   END COMPONENT;
   COMPONENT IBUF
   GENERIC (
      CAPACITANCE      : string;
      IBUF_DELAY_VALUE : string;
      IBUF_LOW_PWR     : boolean;
      IFD_DELAY_VALUE  : string;
      IOSTANDARD       : string
   );
   PORT (
      I : IN     std_ulogic;
      O : OUT    std_ulogic
   );
   END COMPONENT;
   COMPONENT OBUF
   GENERIC (
      CAPACITANCE : string;
      DRIVE       : integer;
      IOSTANDARD  : string;
      SLEW        : string
   );
   PORT (
      I : IN     std_ulogic;
      O : OUT    std_ulogic
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : BUFG USE ENTITY unisim.BUFG;
   FOR ALL : CLKDLL USE ENTITY unisim.CLKDLL;
   FOR ALL : ClockGen USE ENTITY Cosmix_lib.ClockGen;
   FOR ALL : IBUF USE ENTITY unisim.IBUF;
   FOR ALL : OBUF USE ENTITY unisim.OBUF;
   FOR ALL : SPI_CTR USE ENTITY Cosmix_lib.SPI_CTR;
   FOR ALL : SPI_DAC USE ENTITY Cosmix_lib.SPI_DAC;
   FOR ALL : spi_cfg USE ENTITY Cosmix_lib.spi_cfg;
   -- pragma synthesis_on


BEGIN

   -- ModuleWare code(v1.9) for instance 'I61' of 'and'
   TRIG <= hit(0) AND hit(1);

   -- ModuleWare code(v1.9) for instance 'I2' of 'gnd'
   gnd <= '0';

   -- ModuleWare code(v1.9) for instance 'I18' of 'inv'
   GPRST <= NOT(LOCKED0);

   -- ModuleWare code(v1.9) for instance 'I19' of 'inv'
   RST <= NOT(LOCKED1);

   -- ModuleWare code(v1.9) for instance 'I3' of 'vdd'
   vdd <= '1';

   -- Instance port mappings.
   I15 : ClockGen
      PORT MAP (
         CK100H => CK100H,
         CK100K => CK100K,
         GK50M  => GK50M,
         Rst    => GPRST
      );
   I44 : SPI_CTR
      GENERIC MAP (
         ncoinc => 6
      )
      PORT MAP (
         Rst   => GPRST,
         SPCK  => SPCKbuf,
         SPDI  => SPMOSI,
         Outz  => Outz,
         SPCSn => SPCSn,
         CTEN  => CTEN,
         CTOE  => CTOE,
         CTCLR => CTCLR,
         GCK   => GK50M,
         SVar  => SVar,
         SPDO  => SPMISO,
         CTIN  => CTWORD
      );
   I47 : SPI_DAC
      PORT MAP (
         Rst   => GPRST,
         SPCK  => SPCKbuf,
         SPDI  => SPMOSI,
         Outz  => OPEN,
         SPCSn => SPCSn,
         SDCSn => SDCSn,
         SDCK  => SDCK,
         SDCLn => SDCLn,
         SDDI  => SDDI,
         GCK   => GK50M,
         SVar  => OPEN
      );
   I1 : spi_cfg
      GENERIC MAP (
         opc  => 16#88#,
         ncfg => ncoinc
      )
      PORT MAP (
         reset => GPRST,
         ck    => SPCKbuf,
         SPDI  => SPMOSI,
         SPCSn => SPCSn,
         SPDO  => SPMISO,
         cfg   => MM
      );
   I5 : spi_cfg
      GENERIC MAP (
         opc  => 16#84#,
         ncfg => nstream
      )
      PORT MAP (
         reset => GPRST,
         ck    => SPCKbuf,
         SPDI  => SPMOSI,
         SPCSn => SPCSn,
         SPDO  => SPMISO,
         cfg   => hit_width
      );
   I8 : spi_cfg
      GENERIC MAP (
         opc  => 16#85#,
         ncfg => nstream
      )
      PORT MAP (
         reset => GPRST,
         ck    => SPCKbuf,
         SPDI  => SPMOSI,
         SPCSn => SPCSn,
         SPDO  => SPMISO,
         cfg   => tDelay
      );
   bufg100 : BUFG
      PORT MAP (
         O => CLKIN,
         I => CK100M
      );
   bufg100fb : BUFG
      PORT MAP (
         O => GK50M,
         I => CLK1
      );
   bufg200 : BUFG
      PORT MAP (
         O => GK200M,
         I => CK200M
      );
   bufg200fb : BUFG
      PORT MAP (
         O => GK100M,
         I => CLK0
      );
   dll100 : CLKDLL
      GENERIC MAP (
         CLKDV_DIVIDE          => 2.0,
         DUTY_CYCLE_CORRECTION => true,
         FACTORY_JF            => X"C080",
         STARTUP_WAIT          => false
      )
      PORT MAP (
         CLK0   => CLK1,
         CLK180 => OPEN,
         CLK270 => OPEN,
         CLK2X  => CK100M,
         CLK90  => OPEN,
         CLKDV  => OPEN,
         LOCKED => LOCKED1,
         CLKFB  => GK50M,
         CLKIN  => CK50M,
         RST    => PRST
      );
   dll200 : CLKDLL
      GENERIC MAP (
         CLKDV_DIVIDE          => 2.0,
         DUTY_CYCLE_CORRECTION => true,
         FACTORY_JF            => X"C080",
         STARTUP_WAIT          => false
      )
      PORT MAP (
         CLK0   => CLK0,
         CLK180 => OPEN,
         CLK270 => OPEN,
         CLK2X  => CK200M,
         CLK90  => OPEN,
         CLKDV  => OPEN,
         LOCKED => LOCKED0,
         CLKFB  => GK100M,
         CLKIN  => CLKIN,
         RST    => RST
      );
   I4 : IBUF
      GENERIC MAP (
         CAPACITANCE      => "DONT_CARE",
         IBUF_DELAY_VALUE => "0",
         IBUF_LOW_PWR     => TRUE,
         IFD_DELAY_VALUE  => "AUTO",
         IOSTANDARD       => "DEFAULT"
      )
      PORT MAP (
         O => SPCKbuf,
         I => SPCK
      );
   I45 : OBUF
      GENERIC MAP (
         CAPACITANCE => "DONT_CARE",
         DRIVE       => 12,
         IOSTANDARD  => "DEFAULT",
         SLEW        => "SLOW"
      )
      PORT MAP (
         O => D0SpCSn,
         I => gnd
      );
   I46 : OBUF
      GENERIC MAP (
         CAPACITANCE => "DONT_CARE",
         DRIVE       => 12,
         IOSTANDARD  => "DEFAULT",
         SLEW        => "SLOW"
      )
      PORT MAP (
         O => D1SpCSn,
         I => gnd
      );
   I71 : OBUF
      GENERIC MAP (
         CAPACITANCE => "DONT_CARE",
         DRIVE       => 12,
         IOSTANDARD  => "DEFAULT",
         SLEW        => "SLOW"
      )
      PORT MAP (
         O => D2SpCSn,
         I => gnd
      );
   I72 : OBUF
      GENERIC MAP (
         CAPACITANCE => "DONT_CARE",
         DRIVE       => 12,
         IOSTANDARD  => "DEFAULT",
         SLEW        => "SLOW"
      )
      PORT MAP (
         O => D3SpCSn,
         I => gnd
      );
   I73 : OBUF
      GENERIC MAP (
         CAPACITANCE => "DONT_CARE",
         DRIVE       => 12,
         IOSTANDARD  => "DEFAULT",
         SLEW        => "SLOW"
      )
      PORT MAP (
         O => Sp0,
         I => sigOut(2)
      );
   I74 : OBUF
      GENERIC MAP (
         CAPACITANCE => "DONT_CARE",
         DRIVE       => 12,
         IOSTANDARD  => "DEFAULT",
         SLEW        => "SLOW"
      )
      PORT MAP (
         O => Sp1,
         I => sigOut(3)
      );

   g0: FOR i IN 0 TO ncoinc-1 GENERATE
   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : Count USE ENTITY Cosmix_lib.Count;
   FOR I42 : OBUFn USE ENTITY Cosmix_lib.OBUFn;
   FOR ALL : SpCoBlock USE ENTITY Cosmix_lib.SpCoBlock;
   -- pragma synthesis_on

   BEGIN
      I42 : OBUFn
         PORT MAP (
            I => FL(i),
            Pn => CLEDn(i)
         );
      I58 : SpCoBlock
         GENERIC MAP (
            nstream => 4
         )
         PORT MAP (
            CK50M => GK50M,
            CK_FL => CK100H,
            H => sigOut,
            RST => GPRST,
            Veto => gnd,
            M => MM(i)(3 downto 0),
            Coinc => CC(i),
            FL => FL(i)
         );
      I6 : Count
         GENERIC MAP (
            width => 32
         )
         PORT MAP (
            CtCk => GK50M,
            CtClr => CTCLR,
            CtEn => CTEN,
            CtWord => CTWORD,
            CtGo => CC(i),
            CtOE => CTOE(i)
         );
   END GENERATE g0;

   g1: FOR i IN 0 TO nstream -1 GENERATE
   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : IBUF USE ENTITY unisim.IBUF;
   FOR I49 : OBUFn USE ENTITY Cosmix_lib.OBUFn;
   FOR ALL : SpHitBlock USE ENTITY Cosmix_lib.SpHitBlock;
   FOR ALL : delay USE ENTITY Cosmix_lib.delay;
   -- pragma synthesis_on

   BEGIN
      I49 : OBUFn
         PORT MAP (
            I => HFL(i),
            Pn => HLEDn(i)
         );
      I0 : SpHitBlock
         PORT MAP (
            clk => GK50M,
            clk_fl => CK100H,
            reset => GPRST,
            pulse => pulse_buf(i),
            hit => Hit(i),
            fl => HFL(i),
            out_width => hit_width(i)(3 downto 0)
         );
      I7 : IBUF
         GENERIC MAP (
            CAPACITANCE      => "DONT_CARE",
            IBUF_DELAY_VALUE => "0",
            IBUF_LOW_PWR     => TRUE,
            IFD_DELAY_VALUE  => "AUTO",
            IOSTANDARD       => "DEFAULT"
         )
         PORT MAP (
            I => Pulse(i),
            O => pulse_buf(i)
         );
      I9 : delay
         PORT MAP (
            GK200M => GK200M,
            GK50M => GK50M,
            sigIn => hit(i),
            sigOut => sigOut(i),
            tDelay => tDelay(i)(7 downto 0)
         );
   END GENERATE g1;

END struct;
