--
-- VHDL Architecture Cosmix_lib.delay.delay_arch
--
-- Created:
--          by - wotton.UNKNOWN (PCJL)
--          at - 12:15:55 23/07/2012
--
-- using Mentor Graphics HDL Designer(TM) 2010.3 (Build 21)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
LIBRARY Cosmix_lib;
USE Cosmix_lib.Cosmix.all;

ENTITY delay IS
   PORT( 
      sigIn  : IN     std_logic;
      sigOut : OUT    std_logic;
      tDelay : IN     integer
   );

-- Declarations

END delay ;

--
ARCHITECTURE delay_arch OF delay IS
  signal tDelayTime : time := 0ns;        -- Time instance of tDelay
BEGIN
  -- purpose: Delays 'sigIn' for 'tDelay'ns then outputs 'sigOut'.
  -- type   : combinational
  -- inputs : sigIn tDelay
  -- outputs: sigOut
  sigDelay: process (tDelay)
  begin  -- process tFreqConv
    tDelayTime <= tDelay * 1ns;
    sigOut <= transport sigIn after tDelayTime;
  end process sigDelay;
END ARCHITECTURE delay_arch;
