-- VHDL Entity Cosmix_lib.FlashLong.symbol
--
-- Created:
--          by - hommels.users (pcix.hep.phy.private.cam.ac.uk)
--          at - 11:11:26 07/01/11
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;
USE ieee.std_logic_unsigned.all;

ENTITY FlashLong IS
   GENERIC( 
      FLCountMax : integer := 20
   );
   PORT( 
      CO  : IN     std_logic;
      Ck  : IN     std_logic;
      Rst : IN     std_logic;
      FL  : OUT    std_logic
   );

-- Declarations

END FlashLong ;

--
-- VHDL Architecture Cosmix_lib.FlashLong.Simple
--
-- Created:
--          by - hommels.users (pcix.hep.phy.private.cam.ac.uk)
--          at - 11:11:26 07/01/11
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--

ARCHITECTURE Simple OF FlashLong IS

   -- Architecture declarations
   --signal FLCount : std_logic_vector(5 downto 0) := "111111" ;
   signal FLCount : integer range 0 to 1000 ;

BEGIN

   -----------------------------------------------------------------
   process0_proc : PROCESS (Ck,CO,Rst)
   -----------------------------------------------------------------
   BEGIN
      IF  (Rst = '1')  THEN
         FLCount <= FLCountMax ;
      ELSIF (CO = '1') THEN
         FLCount <= 0 ;
      ELSIF (rising_edge(Ck)) THEN
         IF (FLCount >= FLCountMax)  THEN
            -- generic value
                 FLCount <= FLCountMax ;
         ELSE
            -- Inc FLCount
            FLCount <= FLCount + 1 ;
         END IF;
      END IF;
      IF ((FLCount >=0) and (FLCount < (FLCountMax/2)))  THEN
         FL <= '1';
      ELSE
         FL <= '0';
      END IF;
   END PROCESS process0_proc;


END Simple;
