-- VHDL Entity Cosmix_lib.singleshot.symbol
--
-- Created:
--          by - hommels.users (pcix.hep.phy.private.cam.ac.uk)
--          at - 11:31:17 07/01/11
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_arith.all;
USE IEEE.std_logic_misc.all;
USE IEEE.std_logic_unsigned.all;

ENTITY singleshot IS
   PORT( 
      reset  : IN     std_logic;
      clk    : IN     std_logic;
      sigin  : IN     std_logic;
      sigout : OUT    std_logic
   );

-- Declarations

END singleshot ;

--
-- VHDL Architecture Cosmix_lib.singleshot.singleshot_arch
--
-- Created:
--          by - hommels.users (pcix.hep.phy.private.cam.ac.uk)
--          at - 11:31:17 07/01/11
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
 
ARCHITECTURE singleshot_arch OF singleshot IS

   -- Architecture Declarations
   signal siginint : std_logic;
   signal sigoutint : std_logic;

   TYPE STATE_TYPE IS (
      idle,
      doshot
   );
 
   -- Declare current and next state signals
   SIGNAL currentstate : STATE_TYPE;
   SIGNAL nextstate : STATE_TYPE;

BEGIN

   -----------------------------------------------------------------
   clocked_proc : PROCESS ( 
      clk,
      reset
   )
   -----------------------------------------------------------------
   BEGIN
      IF ( reset = '1' ) THEN
         currentstate <= idle;
      ELSIF ( clk'event and clk = '1') THEN
         currentstate <= nextstate;
      END IF;
   END PROCESS clocked_proc;
 
   -----------------------------------------------------------------
   nextstate_proc : PROCESS ( 
      currentstate,
      siginint
   )
   -----------------------------------------------------------------
   BEGIN

      -- Combined Actions
      CASE currentstate IS
         WHEN idle => 
            sigoutint <= '0';
            IF (siginint = '1') THEN 
               nextstate <= doshot;
            ELSE
               nextstate <= idle;
            END IF;
         WHEN doshot => 
            sigoutint <= '1';
            nextstate <= idle;
         WHEN OTHERS =>
            nextstate <= idle;
            sigoutint <= '0';
      END CASE;
   END PROCESS nextstate_proc;
 
   -- Concurrent Statements
     
     -- synchronise sigin input signal to avoid undefined states and/or race conditions
     syncsigin: process (sigoutint, sigin)
     begin  -- process syncsigin
       if sigoutint = '1' then
         siginint <= '0';
       elsif sigin'event and sigin = '1' then
         siginint <= '1';
       end if;
     end process syncsigin;
     -- singleshot_arch
   
   sigout <= sigoutint;
END singleshot_arch;
