-- VHDL Entity Cosmix_lib.SpCoBlock.symbol
--
-- Created:
--          by - Matthew.UNKNOWN (PCJL)
--          at - 10:21:39 26/07/2012
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2010.3 (Build 21)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY SpCoBlock IS
   GENERIC( 
      nstream : integer := 4
   );
   PORT( 
      CK50M : IN     std_logic;
      CK_FL : IN     std_logic;
      H     : IN     std_logic_vector (nstream-1 DOWNTO 0);
      M     : IN     std_logic_vector (nstream-1 DOWNTO 0);
      RST   : IN     std_logic;
      Veto  : IN     std_logic;
      Coinc : OUT    std_logic;
      FL    : OUT    std_logic
   );

-- Declarations

END SpCoBlock ;

--
-- VHDL Architecture Cosmix_lib.SpCoBlock.struct
--
-- Created:
--          by - Matthew.UNKNOWN (PCJL)
--          at - 10:21:40 26/07/2012
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2010.3 (Build 21)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;

LIBRARY Cosmix_lib;

ARCHITECTURE struct OF SpCoBlock IS

   -- Architecture declarations

   -- Internal signal declarations

   -- Implicit buffer signal declarations
   SIGNAL Coinc_internal : std_logic;


   -- Component Declarations
   COMPONENT Flash
   GENERIC (
      FLCountMax : integer := 20
   );
   PORT (
      CO  : IN     std_logic ;
      Ck  : IN     std_logic ;
      FL  : OUT    std_logic ;
      Rst : IN     std_logic 
   );
   END COMPONENT;
   COMPONENT SpCoLog
   GENERIC (
      nstream : integer := 4
   );
   PORT (
      CK50M : IN     std_logic ;
      H     : IN     std_logic_vector (nstream-1 DOWNTO 0);
      M     : IN     std_logic_vector (nstream-1 DOWNTO 0);
      Veto  : IN     std_logic ;
      Coinc : OUT    std_logic 
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : Flash USE ENTITY Cosmix_lib.Flash;
   FOR ALL : SpCoLog USE ENTITY Cosmix_lib.SpCoLog;
   -- pragma synthesis_on


BEGIN

   -- Instance port mappings.
   I0 : Flash
      GENERIC MAP (
         FLCountMax => 20
      )
      PORT MAP (
         CO  => Coinc_internal,
         Ck  => CK_FL,
         FL  => FL,
         Rst => RST
      );
   I1 : SpCoLog
      GENERIC MAP (
         nstream => 4
      )
      PORT MAP (
         CK50M => CK50M,
         H     => H,
         M     => M,
         Veto  => Veto,
         Coinc => Coinc_internal
      );

   -- Implicit buffered output assignments
   Coinc <= Coinc_internal;

END struct;
