--------------------------------------------------------------------------------
-- Copyright (c) 1995-2011 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 13.2
--  \   \         Application : sch2hdl
--  /   /         Filename : UARTDataReadout.vhf
-- /___/   /\     Timestamp : 08/09/2012 09:08:46
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan6 -flat -suppress -vhdl Q:/users/matthew/HDL/CosmixGPS/CosmixGPS/UARTDataReadout.vhf -w Q:/users/matthew/HDL/CosmixGPS/CosmixGPS/UARTDataReadout.sch
--Design Name: UARTDataReadout
--Device: spartan6
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--
----- CELL CB4CE_HXILINX_UARTDataReadout -----


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity CB4CE_HXILINX_UARTDataReadout is
  
port (
    CEO  : out STD_LOGIC;
    Q0   : out STD_LOGIC;
    Q1   : out STD_LOGIC;
    Q2   : out STD_LOGIC;
    Q3   : out STD_LOGIC;
    TC   : out STD_LOGIC;
    C    : in STD_LOGIC;
    CE   : in STD_LOGIC;
    CLR  : in STD_LOGIC
    );
end CB4CE_HXILINX_UARTDataReadout;

architecture Behavioral of CB4CE_HXILINX_UARTDataReadout is

  signal COUNT : STD_LOGIC_VECTOR(3 downto 0) := (others => '0');
  constant TERMINAL_COUNT : STD_LOGIC_VECTOR(3 downto 0) := (others => '1');
  
begin

process(C, CLR)
begin
  if (CLR='1') then
    COUNT <= (others => '0');
  elsif (C'event and C = '1') then
    if (CE='1') then 
      COUNT <= COUNT+1;
    end if;
  end if;
end process;

TC   <=  '0' when (CLR = '1') else
         '1' when (COUNT = TERMINAL_COUNT) else '0';
CEO  <= '1' when ((COUNT = TERMINAL_COUNT) and CE='1') else '0';

Q3 <= COUNT(3);
Q2 <= COUNT(2);
Q1 <= COUNT(1);
Q0 <= COUNT(0);

end Behavioral;

----- CELL M16_1E_HXILINX_UARTDataReadout -----
  
library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity M16_1E_HXILINX_UARTDataReadout is
  
port(
    O    : out std_logic;

    D0   : in std_logic;
    D1   : in std_logic;
    D2   : in std_logic;
    D3   : in std_logic;
    D4   : in std_logic;
    D5   : in std_logic;
    D6   : in std_logic;
    D7   : in std_logic;
    D8   : in std_logic;
    D9   : in std_logic;
    D10  : in std_logic;
    D11  : in std_logic;
    D12  : in std_logic;
    D13  : in std_logic;
    D14  : in std_logic;
    D15  : in std_logic;
    E    : in std_logic;
    S0   : in std_logic;
    S1   : in std_logic;
    S2   : in std_logic;
    S3   : in std_logic
  );
end M16_1E_HXILINX_UARTDataReadout;

architecture M16_1E_HXILINX_UARTDataReadout_V of M16_1E_HXILINX_UARTDataReadout is
begin
  process (D0, D1, D2, D3, D4, D5, D6, D7, D8, D9, D10, D11, D12, D13, D14, D15, E, S0, S1, S2, S3)
  variable sel : std_logic_vector(3 downto 0);
  begin
    sel := S3&S2&S1&S0;
    if( E = '0') then
    O <= '0';
    else
      case sel is
      when "0000" => O <= D0;
      when "0001" => O <= D1;
      when "0010" => O <= D2;
      when "0011" => O <= D3;
      when "0100" => O <= D4;
      when "0101" => O <= D5;
      when "0110" => O <= D6;
      when "0111" => O <= D7;
      when "1000" => O <= D8;
      when "1001" => O <= D9;
      when "1010" => O <= D10;
      when "1011" => O <= D11;
      when "1100" => O <= D12;
      when "1101" => O <= D13;
      when "1110" => O <= D14;
      when "1111" => O <= D15;
      when others => NULL;
      end case;
    end if;
    end process; 
end M16_1E_HXILINX_UARTDataReadout_V;

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity UARTDriver_MUSER_UARTDataReadout is
   port ( clk       : in    std_logic; 
          dataIn    : in    std_logic_vector (7 downto 0); 
          dataReady : in    std_logic; 
          serialOut : out   std_logic);
end UARTDriver_MUSER_UARTDataReadout;

architecture BEHAVIORAL of UARTDriver_MUSER_UARTDataReadout is
   attribute HU_SET     : string ;
   attribute BOX_TYPE   : string ;
   signal XLXN_44               : std_logic;
   signal XLXN_47               : std_logic;
   signal XLXN_48               : std_logic;
   signal XLXN_52               : std_logic;
   signal XLXN_53               : std_logic;
   signal XLXN_55               : std_logic;
   signal XLXN_62               : std_logic;
   signal XLXI_6_D10_openSignal : std_logic;
   signal XLXI_6_D11_openSignal : std_logic;
   signal XLXI_6_D12_openSignal : std_logic;
   signal XLXI_6_D13_openSignal : std_logic;
   signal XLXI_6_D14_openSignal : std_logic;
   signal XLXI_6_D15_openSignal : std_logic;
   component CB4CE_HXILINX_UARTDataReadout
      port ( C   : in    std_logic; 
             CE  : in    std_logic; 
             CLR : in    std_logic; 
             CEO : out   std_logic; 
             Q0  : out   std_logic; 
             Q1  : out   std_logic; 
             Q2  : out   std_logic; 
             Q3  : out   std_logic; 
             TC  : out   std_logic);
   end component;
   
   component M16_1E_HXILINX_UARTDataReadout
      port ( D0  : in    std_logic; 
             D1  : in    std_logic; 
             D10 : in    std_logic; 
             D11 : in    std_logic; 
             D12 : in    std_logic; 
             D13 : in    std_logic; 
             D14 : in    std_logic; 
             D15 : in    std_logic; 
             D2  : in    std_logic; 
             D3  : in    std_logic; 
             D4  : in    std_logic; 
             D5  : in    std_logic; 
             D6  : in    std_logic; 
             D7  : in    std_logic; 
             D8  : in    std_logic; 
             D9  : in    std_logic; 
             E   : in    std_logic; 
             S0  : in    std_logic; 
             S1  : in    std_logic; 
             S2  : in    std_logic; 
             S3  : in    std_logic; 
             O   : out   std_logic);
   end component;
   
   component GND
      port ( G : out   std_logic);
   end component;
   attribute BOX_TYPE of GND : component is "BLACK_BOX";
   
   component VCC
      port ( P : out   std_logic);
   end component;
   attribute BOX_TYPE of VCC : component is "BLACK_BOX";
   
   component NAND4B2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             I3 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of NAND4B2 : component is "BLACK_BOX";
   
   attribute HU_SET of UART_COUNTER : label is "UART_COUNTER_5";
   attribute HU_SET of XLXI_6 : label is "XLXI_6_6";
begin
   UART_COUNTER : CB4CE_HXILINX_UARTDataReadout
      port map (C=>clk,
                CE=>XLXN_55,
                CLR=>dataReady,
                CEO=>open,
                Q0=>XLXN_47,
                Q1=>XLXN_52,
                Q2=>XLXN_48,
                Q3=>XLXN_53,
                TC=>open);
   
   XLXI_6 : M16_1E_HXILINX_UARTDataReadout
      port map (D0=>XLXN_44,
                D1=>dataIn(0),
                D2=>dataIn(1),
                D3=>dataIn(2),
                D4=>dataIn(3),
                D5=>dataIn(4),
                D6=>dataIn(5),
                D7=>dataIn(6),
                D8=>dataIn(7),
                D9=>XLXN_62,
                D10=>XLXI_6_D10_openSignal,
                D11=>XLXI_6_D11_openSignal,
                D12=>XLXI_6_D12_openSignal,
                D13=>XLXI_6_D13_openSignal,
                D14=>XLXI_6_D14_openSignal,
                D15=>XLXI_6_D15_openSignal,
                E=>XLXN_62,
                S0=>XLXN_47,
                S1=>XLXN_52,
                S2=>XLXN_48,
                S3=>XLXN_53,
                O=>serialOut);
   
   XLXI_7 : GND
      port map (G=>XLXN_44);
   
   XLXI_8 : VCC
      port map (P=>XLXN_62);
   
   XLXI_12 : NAND4B2
      port map (I0=>XLXN_48,
                I1=>XLXN_47,
                I2=>XLXN_53,
                I3=>XLXN_52,
                O=>XLXN_55);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity CommandDetector_MUSER_UARTDataReadout is
   port ( data      : in    std_logic_vector (7 downto 0); 
          dataReady : in    std_logic; 
          newCom    : out   std_logic; 
          newData   : out   std_logic);
end CommandDetector_MUSER_UARTDataReadout;

architecture BEHAVIORAL of CommandDetector_MUSER_UARTDataReadout is
   attribute BOX_TYPE   : string ;
   signal comEnable   : std_logic;
   signal newDataRaw  : std_logic;
   signal NEW_COM_RAW : std_logic;
   signal XLXN_115    : std_logic;
   component FD
      generic( INIT : bit :=  '0');
      port ( C : in    std_logic; 
             D : in    std_logic; 
             Q : out   std_logic);
   end component;
   attribute BOX_TYPE of FD : component is "BLACK_BOX";
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of INV : component is "BLACK_BOX";
   
   component NOR5
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             I3 : in    std_logic; 
             I4 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of NOR5 : component is "BLACK_BOX";
   
   component AND5
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             I3 : in    std_logic; 
             I4 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND5 : component is "BLACK_BOX";
   
   component AND2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2 : component is "BLACK_BOX";
   
begin
   XLXI_25 : FD
      port map (C=>comEnable,
                D=>newDataRaw,
                Q=>NEW_COM_RAW);
   
   XLXI_26 : INV
      port map (I=>NEW_COM_RAW,
                O=>newDataRaw);
   
   XLXI_39 : NOR5
      port map (I0=>data(2),
                I1=>data(3),
                I2=>data(4),
                I3=>data(6),
                I4=>data(7),
                O=>XLXN_115);
   
   XLXI_44 : AND5
      port map (I0=>dataReady,
                I1=>data(0),
                I2=>data(1),
                I3=>data(5),
                I4=>XLXN_115,
                O=>comEnable);
   
   XLXI_56 : AND2
      port map (I0=>comEnable,
                I1=>newDataRaw,
                O=>newData);
   
   XLXI_57 : AND2
      port map (I0=>comEnable,
                I1=>NEW_COM_RAW,
                O=>newCom);
   
end BEHAVIORAL;



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity UARTDataReadout is
   port ( clk       : in    std_logic; 
          clk4x     : in    std_logic; 
          dataIn    : in    std_logic_vector (7 downto 0); 
          dataReady : in    std_logic; 
          rst       : in    std_logic; 
          serRxd    : in    std_logic; 
          dataOut   : out   std_logic_vector (7 downto 0); 
          newCom    : out   std_logic; 
          newData   : out   std_logic; 
          serTxd    : out   std_logic);
end UARTDataReadout;

architecture BEHAVIORAL of UARTDataReadout is
   signal XLXN_14       : std_logic;
   signal dataOut_DUMMY : std_logic_vector (7 downto 0);
   component CommandDetector_MUSER_UARTDataReadout
      port ( data      : in    std_logic_vector (7 downto 0); 
             dataReady : in    std_logic; 
             newData   : out   std_logic; 
             newCom    : out   std_logic);
   end component;
   
   component DataSynchroniser
      port ( serialIn : in    std_logic; 
             clk4x    : in    std_logic; 
             rst      : in    std_logic; 
             newData  : out   std_logic; 
             dataOut  : out   std_logic_vector (7 downto 0));
   end component;
   
   component UARTDriver_MUSER_UARTDataReadout
      port ( clk       : in    std_logic; 
             dataIn    : in    std_logic_vector (7 downto 0); 
             dataReady : in    std_logic; 
             serialOut : out   std_logic);
   end component;
   
begin
   dataOut(7 downto 0) <= dataOut_DUMMY(7 downto 0);
   UART_CMD_DET : CommandDetector_MUSER_UARTDataReadout
      port map (data(7 downto 0)=>dataOut_DUMMY(7 downto 0),
                dataReady=>XLXN_14,
                newCom=>newCom,
                newData=>newData);
   
   UART_DATA_SYNC : DataSynchroniser
      port map (clk4x=>clk4x,
                rst=>rst,
                serialIn=>serRxd,
                dataOut(7 downto 0)=>dataOut_DUMMY(7 downto 0),
                newData=>XLXN_14);
   
   XLXI_1 : UARTDriver_MUSER_UARTDataReadout
      port map (clk=>clk,
                dataIn(7 downto 0)=>dataIn(7 downto 0),
                dataReady=>dataReady,
                serialOut=>serTxd);
   
end BEHAVIORAL;


